#include<bits/stdc++.h>
using namespace std;
const int N=1e5+5;
int edge[N*2],head[N*2],nxt[N*2],cnt=0;
int f[N][25],dep[N];
int lcaa;
int n;
void add(int u,int v)
{
	edge[++cnt]=v;nxt[cnt]=head[u];head[u]=cnt;
}
void dfs(long long x,long long fa)
{
	if(x<0) return;
	dep[x]=dep[fa]+1;
	f[x][0]=fa;
	for(int i=1;i<=21;i++){
		f[x][i]=f[f[x][i-1]][i-1];
	}
	for(int i=head[x];i;i=nxt[i])
	{
		int v=edge[i];
		if(v==fa) continue;
		dfs(v,x);
	}
}
void dfs2(long long x,long long fa)
{
	if(x<0) return;
	dep[x]=dep[fa]+1;
	for(int i=head[x];i;i=nxt[i])
	{
		int v=edge[i];
		if(v==fa) continue;
		dfs(v,x);
	}
}
int LCaa(int x,int y)
{
	if(x==y) return x;
	if(dep[x]<dep[y]){
		swap(x,y);
	}
	for(int i=21;i>=0;i--)
	{
		if(dep[f[x][i]]>=dep[y]){
			x=f[x][i];
		}
	}
	if(x==y) return x;
	for(int i=21;i>=0;i--)
	{
		if(f[x][i]!=f[y][i])
		{
			x=f[x][i];
			y=f[y][i];
		}
	}
	return f[x][0];
}
void solve1()
{
	for(int i=1;i<n;i++)
	{
		int u,v;
		cin>>u>>v;
		if(u==v) continue;
		add(u,v);
		add(v,u);
	}
	dfs(1,0);
//	for(int i=1;i<n;i++)
//	{
//		lcaa[i]=LCaa(i,i+1);
//		//cout<<lcaa[i]<<" ";
//	}
	int m;
	cin>>m;
	for(int i=1;i<=m;i++)
	{
		int l,r,k;
		cin>>l>>r>>k;
		int ans=0;
		for(int j=l;j+k-1<=r;j++)
		{
			lcaa=j;
			for(int z=j+1;z<=j+k-1;z++){
				lcaa=LCaa(lcaa,z);
			}
			ans=max(ans,dep[lcaa]);
		 } 
		 cout<<ans<<endl;
	}	
}
void solve2()
{
	for(int i=1;i<n;i++)
	{
		int u,v;
		cin>>u>>v;
		if(u==v) continue;
		add(u,v);
		add(v,u);
	}
	dfs2(1,0);
	int m;
	cin>>m;
	for(int i=1;i<=m;i++)
	{
		int l,r,k;
		cin>>l>>r>>k;
		int ans=0;
		for(int j=r-k+1;j<=r;j++)
		{
			ans=max(ans,dep[j]);
		}
		cout<<ans;
	}
}
int main()
{
	freopen("query.in","r",stdin);
	freopen("query.out","w",stdout);
	cin>>n;
	if(n<=5005)
	{
		solve1();
	}
	else 
	{
		solve2();
	}
	return 0;
}
/*
6
5 6
6 1
6 2
2 3
2 4
3
2 5 2
1 4 1
1 6 3


*/
